VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "ShellLink"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
Option Explicit

'      ...     ...
'  ?   ,    SDK Help  "in vTable Order",
'    ,    "in vTable Order"!
'     .h,   ...
'      .

' : IPersistFile  .    IShellLink.


Private Const CLSID_ShellLink As String = "{00021401-0000-0000-C000-000000000046}"
Private Const IID_IShellLinkA As String = "{000214EE-0000-0000-C000-000000000046}"
'Private Const IID_IShellLinkW As String = "{000214F9-0000-0000-C000-000000000046}"
Private Const IID_IPersistFile As String = "{0000010b-0000-0000-C000-000000000046}"

Private Const shl_GetArguments As Long = 10 ' 3
Private Const shl_GetDescription As Long = 6 '4
Private Const shl_GetHotkey As Long = 12 '5
Private Const shl_GetIconLocation As Long = 16 '6
'Private Const shl_GetIDList As Long = 4 '7
Private Const shl_GetPath As Long = 3 '8
Private Const shl_GetShowCmd As Long = 14 ' 9
Private Const shl_GetWorkingDirectory As Long = 8 '10
Private Const shl_Resolve As Long = 19 '11
Private Const shl_SetArguments As Long = 11 '12
Private Const shl_SetDescription As Long = 7 '13
Private Const shl_SetHotkey As Long = 13 '14
Private Const shl_SetIconLocation As Long = 17 '15
'Private Const shl_SetIDList As Long = 5 '16
Private Const shl_SetPath As Long = 20 '17
Private Const shl_SetRelativePath As Long = 18 '18
Private Const shl_SetShowCmd As Long = 15 '19
Private Const shl_SetWorkingDirectory As Long = 9 '20

'Private Const prsf_GetClassID As Long = 3 '      ...
'Private Const prsf_IsDirty As Long = 4 '3
Private Const prsf_Load As Long = 5 '4
Private Const prsf_Save As Long = 6 '5
'Private Const prsf_SaveCompleted As Long = 7 '6
'Private Const prsf_GetCurFile As Long = 8 '7

Private Const MAX_PATH As Long = 260

Private pMe As Long, pMyPersistFile As Long, LoadedFrom As String

Private Sub Class_Initialize()
  Dim MyGuid As modOLECommon.Guid, tmpInterface As modOLECommon.Guid
  
  modOLECommon.CLSIDFromString StrConv(CLSID_ShellLink, vbUnicode), MyGuid
  modOLECommon.IIDFromString StrConv(IID_IShellLinkA, vbUnicode), tmpInterface
  modOLECommon.CoCreateInstance MyGuid, 0, 1, tmpInterface, pMe
  
  modOLECommon.IIDFromString StrConv(IID_IPersistFile, vbUnicode), tmpInterface
  modOLECommon.CallInterface pMe, modOLECommon.unk_QueryInterface, 2, VarPtr(tmpInterface), VarPtr(pMyPersistFile)
End Sub

Private Sub Class_Terminate()
  modOLECommon.CallInterface pMyPersistFile, modOLECommon.unk_Release, 0
  modOLECommon.CallInterface pMe, modOLECommon.unk_Release, 0
End Sub

Public Sub Load(LoadFrom As String)
  modOLECommon.CallInterface pMyPersistFile, prsf_Load, 2, StrPtr(LoadFrom), 2
  LoadedFrom = LoadFrom
End Sub

Public Sub Save(Optional SaveTo As String = vbNullString)
  If Len(SaveTo) Then LoadedFrom = SaveTo
  modOLECommon.CallInterface pMyPersistFile, prsf_Save, 2, StrPtr(LoadedFrom), True
End Sub

Property Get Path() As String
  Path = Space$(MAX_PATH / 2)
  modOLECommon.CallInterface pMe, shl_GetPath, 4, StrPtr(Path), MAX_PATH, 0, 0
  Path = StrConv(Path, vbUnicode)
  Path = Left$(Path, InStr(Path, vbNullChar) - 1)
End Property

Property Let Path(P As String)
  modOLECommon.CallInterface pMe, shl_SetPath, 1, StrPtr(StrConv(P, vbFromUnicode))
End Property

Property Get ShowCommand() As Long
  modOLECommon.CallInterface pMe, shl_GetShowCmd, 1, VarPtr(ShowCommand)
End Property

Property Let ShowCommand(ByVal s As Long)
  modOLECommon.CallInterface pMe, shl_SetShowCmd, 1, s
End Property

Property Get Arguments() As String
  Arguments = Space$(MAX_PATH / 2)
  modOLECommon.CallInterface pMe, shl_GetArguments, 2, StrPtr(Arguments), MAX_PATH
  Arguments = StrConv(Arguments, vbUnicode)
  Arguments = Left$(Arguments, InStr(Arguments, vbNullChar) - 1)
End Property

Property Let Arguments(a As String)
  modOLECommon.CallInterface pMe, shl_SetArguments, 1, StrPtr(StrConv(a, vbFromUnicode))
End Property

Property Get Description() As String
  '    Description.    ...
  Description = Space$(MAX_PATH / 2)
  modOLECommon.CallInterface pMe, shl_GetDescription, 2, StrPtr(Description), MAX_PATH
  Description = StrConv(Description, vbUnicode)
  Description = Left$(Description, InStr(Description, vbNullChar) - 1)
End Property

Property Let Description(d As String)
  modOLECommon.CallInterface pMe, shl_SetDescription, 1, StrPtr(StrConv(d, vbFromUnicode))
End Property

Property Get HotKey() As Integer
  'LOBYTE = VK_CODE
  'HIBYTE = Modifiers (HOTKEY_ALT, HOTKEY_CONTROL, HOTKEY_SHIFT, HOTKEY_EXT)
  modOLECommon.CallInterface pMe, shl_GetHotkey, 1, VarPtr(HotKey)
End Property

Property Let HotKey(ByVal h As Integer)
  modOLECommon.CallInterface pMe, shl_SetHotkey, 1, h
End Property

Public Sub GetIconInfo(ByRef outPath As String, ByRef outIndex As Long)
  outPath = Space$(MAX_PATH)
  modOLECommon.CallInterface pMe, shl_GetIconLocation, 3, StrPtr(outPath), MAX_PATH, VarPtr(outIndex)
  outPath = StrConv(outPath, vbUnicode)
  outPath = Left$(outPath, InStr(outPath, vbNullChar) - 1)
End Sub

Public Sub SetIconInfo(Path As String, ByVal Index As Long)
  modOLECommon.CallInterface pMe, shl_SetIconLocation, 2, StrPtr(StrConv(Path, vbFromUnicode)), Index
End Sub

Property Get WorkingDirectory() As String
  WorkingDirectory = Space$(MAX_PATH / 2)
  modOLECommon.CallInterface pMe, shl_GetWorkingDirectory, 2, StrPtr(WorkingDirectory), MAX_PATH
  WorkingDirectory = StrConv(WorkingDirectory, vbUnicode)
  WorkingDirectory = Left$(WorkingDirectory, InStr(WorkingDirectory, vbNullChar) - 1)
End Property

Property Let WorkingDirectory(wd As String)
  modOLECommon.CallInterface pMe, shl_SetWorkingDirectory, 1, StrPtr(StrConv(wd, vbFromUnicode))
End Property
